"use strict";
// JavaScript Document

// Fetch Climate UI .
// UI demonstration of design of the regions for an app for the phone that shows
// climate data

var globalVars = {}; // A container for the global variables in this document. To avoid accidents!
var windowWidth = $(window).width();

document.ontouchmove = function(e){ 
    e.preventDefault(); 
}

var tempatureOffset = "-55px 225px";
var tempatureFOffset = "-125px 225px";
var rainOffset = "-270px 225px";
var sunOffset = "-205px 225px";
var humidityOffset = "-345px 225px";

var tempatureOffsetColoured = "-55px 306px";
var tempatureFOffsetColoured = "-125px 306px";
var rainOffsetColoured = "-270px 306px";
var sunOffsetColoured = "-205px 306px";
var humidityOffsetColoured = "-345px 306px";

var monthNames = [ "JANUARY", "FEBURARY", "MARCH", "APRIL", "MAY", "JUNE",
    "JULY", "AUGUST", "SEPTEMBER", "OCTOBER", "NOVEMBER", "DECEMBER"];

var shortMonthNames = [ "JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
var lastMonth = "OCT";
var lastMonthIndex = 9;

var datePickerElement;

// DOCUMENT READY
// Fires once the page has loaded
$(document).ready(function () {

	datePickerElement = document.getElementById("datePicker");

    globalVars.state="home";
    globalVars.lastDateClicked="";

    //Any interaction opens main UI
    var ui = document.getElementById("UI");
    ui.addEventListener("touchstart", interactWithHomeScreen, false);
    ui.addEventListener("mousedown", interactWithHomeScreen, false);
    if (window.navigator.msPointerEnabled) {
            ui.addEventListener("pointerDown", interactWithHomeScreen, false);
            ui.addEventListener("MSPointerDown", interactWithHomeScreen, false);
    }

    if (localStorage.getItem("temp_unit") == "F") {
            $("#temperatureImage").css({ "background-position": tempatureFOffsetColoured });
    } else {
            $("#temperatureImage").css({ "background-position": tempatureOffsetColoured });
    }
    $("#rainImage").css({ "background-position": rainOffset });
    $("#sunImage").css({ "background-position": sunOffset });
    $("#humidityImage").css({ "background-position": humidityOffset });

    var datePicker = document.getElementById("datePicker");

    if (window.navigator.msPointerEnabled) {
      datePicker.addEventListener("pointerDown", pointerDown, false);
      datePicker.addEventListener("MSPointerDown", pointerDown, false);

      datePicker.addEventListener("pointerMove", pointerMove, false);
      datePicker.addEventListener("MSPointerMove", pointerMove, false);

      datePicker.addEventListener("pointerout", pointerOut, false);
      datePicker.addEventListener("MSPointerOut", pointerOut, false);

      datePicker.addEventListener("pointerUp", pointerUp, false);
      datePicker.addEventListener("MSPointerUp", pointerUp, false);
    }
    datePicker.addEventListener("touchmove", handleMove, false);
    datePicker.addEventListener("touchstart", handleStart, false);
    datePicker.addEventListener("touchend", handleEnd, false);


    //October is default
    var monthWidth = $("#JAN0").width();
    offsetX = windowWidth / 2 - lastMonthIndex * monthWidth - 12 * monthWidth - 0.5 * monthWidth;
    $("#" + shortMonthNames[lastMonthIndex] + "1").css({"font-size": "50px", "margin-top": "-14px", "color":"black;"});

    var datePicker = document.getElementById("datePicker");
    datePicker.style.webkitTransform  = "translateX(" + String(offsetX) + "px)";
    datePicker.style.transform  = "translateX(" + String(offsetX) + "px)";

    FC.variable = FC.Settings.TEMP_VARIABLE;
    FC.palette = FC.Settings.TEMP_PALETTE;
    FC.range = FC.Settings.TEMP_RANGE;
    updatePaletteControl();

    init();
    
    initSettings();
	
	var downloadIndicator = $("#download-indicator");
	FC.tileData.addEventListener('beginDownloadData', function () {
	    showDownloadIndicator(downloadIndicator);
        });
        FC.tileData.addEventListener('endDownloadData', function () {
            //document.getElementById('download-indicator').style.backgroundColor = "rgba(0,0,0,0)";
	    //$("#download-indicator").addClass("fadeOut");
	    hideDownloadIndicator(downloadIndicator);
        });
	//$(downloadIndicator).css("left", $(window).width()*0.5-70);
	$(downloadIndicator).css("width", $(window).width());
	
	var winheight = $(window).height();
	$("#out-of-search").css({"top"    : winheight*.1,
				 "height" : winheight*.9});

	//setTimeout(interactWithHomeScreen, 9000);
});

function interactWithHomeScreen(event){

	if (globalVars.state!="place"){
        showMainPage();

        var ui = document.getElementById("UI");
        ui.removeEventListener("touchstart", interactWithHomeScreen, false);
        ui.removeEventListener("mousedown", interactWithHomeScreen, false);
        if (window.navigator.msPointerEnabled) {
            ui.removeEventListener("pointerDown", interactWithHomeScreen, false);
            ui.removeEventListener("MSPointerDown", interactWithHomeScreen, false);
        }

        
    }
}

function showMainPage(){
    
    var millisecondsLeft = new Date(2016, 5, 30) - Date.now(); //June 30th, months are 0-based

    console.log(millisecondsLeft);
    if (millisecondsLeft > 0) {
        if (globalVars.state!="place"){
            globalVars.state="place";

            $("#place").animate({"height": "10%"});
            $("#map").animate({"top": "10%"});

            $("#time").animate({"top": "60%", "height":"15%"});

            $("#climate").animate({"top": "75%", "height": "25%"}, function(){
                $("#map").show();
                $("#map").animate({opacity:1});

                $("#place-center").attr("onclick", "searchPlaceEnter()");
                $("#temperatureImage").click(selectTemperature);
                $("#rainImage").click(selectRain);
                $("#humidityImage").click(selectHumidity);
                $("#sunImage").click(selectSun);  
            });

            $("#iconShare").fadeIn();
            $("#iconSearch").fadeIn();

            $("#iconRow").fadeIn();

            $("#time h2").fadeOut();
            $("#time p").fadeOut();
            $("#time h1").fadeOut(function(){
                $("#datePicker").fadeIn();
            });

            $("#climateChoice").fadeOut(function(){
                $("#climateBar").fadeIn();
            });

            $("#download-indicator").show();
        }
    }
}

var firstX;
var offsetX = 0; //October
var touchMoveCount = 0;

var currentPointerId = -1;

function pointerDown(evt) {
    //selectDateAt(evt.pageX);

	firstX = evt.pageX - offsetX;

    currentPointerId = evt.pointerId;

	datePickerElement.style.transition = "none";

    touchMoveCount = 0;
}

function pointerMove(evt) {
	if (currentPointerId !== -1) {
		touchMoveCount += 1;
	        
	    var newX = evt.clientX;
	    
	    offsetX = newX - firstX;
	    //console.log(offsetX);

	    //datePicker.style.left = String(offsetX) + "px";
	    datePickerElement.style.transform  = "translateX(" + String(offsetX) + "px)";
	}
}

function pointerUp(evt) {
	currentPointerId = -1;
	

	var pointToMatch = windowWidth / 2;
    if (touchMoveCount <= 3) {
            //Guess it's a tap
            pointToMatch = evt.clientX;
    }

    selectDateAt(pointToMatch);
}

function pointerOut(evt) {
    currentPointerId = -1;
    
    var pointToMatch = windowWidth / 2;

    selectDateAt(pointToMatch);
}

function handleStart(evt) {
        evt.preventDefault();

        firstX = evt.touches[0].clientX - offsetX;

        
        datePickerElement.style.transition = "none";

        touchMoveCount = 0;
}

function handleMove(evt) {
        touchMoveCount += 1;
        
        var newX = evt.touches[0].clientX;
        
        offsetX = newX - firstX;

        //datePicker.style.left = String(offsetX) + "px";
        datePickerElement.style.webkitTransform  = "translateX(" + String(offsetX) + "px)";
        datePickerElement.style.transform  = "translateX(" + String(offsetX) + "px)";
        //transform: translateX(-100.0px);
}

function handleEnd(evt) {

        var pointToMatch = windowWidth / 2;
        if (touchMoveCount <= 3) {
                //Guess it's a tap
                pointToMatch = evt.changedTouches[0].pageX;
        }

        selectDateAt(pointToMatch);
}

function selectDateAt(pointToMatch) {
        var datePicker = document.getElementById("datePicker");
        
        var leftOffset = offsetX;

        //Snap to closest month
        var monthItem0 = document.getElementById(shortMonthNames[0]+"0");
        var month0Midpoint = leftOffset + monthItem0.offsetLeft + monthItem0.offsetWidth / 2;

        var closest = 0;
        var closestMidpoint = month0Midpoint;

        var loopOffset = 1;


        for (var i = 0; i < shortMonthNames.length; i++) {
            for (var j = 0; j < 3; j++) {

                var monthItem = document.getElementById(shortMonthNames[i] + String(j));
                var monthMidpoint = leftOffset + monthItem.offsetLeft + monthItem.offsetWidth / 2;

                if (Math.abs(monthMidpoint - pointToMatch) < Math.abs(closestMidpoint - pointToMatch)) {
                    loopOffset = j;
                    closest = i;
                    closestMidpoint = monthMidpoint;
                }
            }
        };


        var moveToLeft = document.getElementById(shortMonthNames[closest] + "1").offsetLeft + document.getElementById(shortMonthNames[closest] + "1").offsetWidth / 2;

        var stopPoint = windowWidth / 2 - moveToLeft;

        
        if (loopOffset === 1) {
            //TODO: shift into range instantly then transition.
            datePickerElement.style.webkitTransition = "all 0.2s ease-in-out";
            datePickerElement.style.transition = "all 0.2s ease-in-out";
            datePickerElement.style.webkitTransform  = "translateX(" + String(stopPoint) + "px)";
            datePickerElement.style.transform  = "translateX(" + String(stopPoint) + "px)";
        } else {
            datePickerElement.style.webkitTransform  = "translateX(" + String(stopPoint) + "px)";
            datePickerElement.style.transform  = "translateX(" + String(stopPoint) + "px)";
        }

        var newMonth = shortMonthNames[closest];

        if (newMonth != lastMonth) {

                $("#" + lastMonth + "1").css({"font-size": "34px", "margin-top": "0px", "color":"grey;"});

                $("#" + shortMonthNames[closest] + "1").css({"font-size": "50px", "margin-top": "-14px", "color":"black;"});

                lastMonth = shortMonthNames[closest];
                lastMonthIndex = closest;

                $("#time h1").text(monthNames[closest]);

                FC.month = closest;
                FC.Map.updateView();
        }

        offsetX = windowWidth / 2 - moveToLeft;
}

var extractor = /rgb\((\d+),(\d+),(\d+)/;

function padHex(inter) {
        var asHex = inter.toString(16);

        if (asHex.length == 1) {
                return "0" + asHex;
        }
        return asHex;
}

function rgbToHex(rgb) {
        var res = extractor.exec(rgb);
        return "#" + padHex(parseInt(res[1])) + padHex(parseInt(res[2])) + padHex(parseInt(res[3])) + "99";
}

function rgbArrayToHex(array) {
        var hexPallete = "";

        for (var i = 0; i < array.length; i++) {
                var hexPallete = hexPallete + "," + rgbToHex(array[i]);

                $("#climate" + String(i+1)).css({"background-color": array[i]});
        }

        //Drop ,
        hexPallete = hexPallete.substring(1, hexPallete.length);

        return hexPallete;
}

function updatePaletteControl() {
        var colors = FC.palette.split("=");
        for (var i = 0; i < colors.length; ++i) {
                $("#climate" + (i + 1)).css({ "background-color": colors[i] });
        }
}

function selectTemperature() {
        if (globalVars.state == "place"){
                if (FC.variable != FC.Settings.TEMP_VARIABLE) {
                        showDescription("Expected high daily TEMPERATURE");
                        FC.variable = FC.Settings.TEMP_VARIABLE;
                        FC.palette = FC.Settings.TEMP_PALETTE;
                        FC.range = FC.Settings.TEMP_RANGE;
                        FC.Map.updateView();
                        updatePaletteControl();

                        if (localStorage.getItem("temp_unit") == "F") {
                                $("#temperatureImage").css({ "background-position": tempatureFOffsetColoured });
                        } else {
                                $("#temperatureImage").css({ "background-position": tempatureOffsetColoured });
                        }
                        $("#rainImage").css({ "background-position": rainOffset });
                        $("#sunImage").css({ "background-position": sunOffset });
                        $("#humidityImage").css({ "background-position": humidityOffset });

                        $(".climateIcon").css({ "opacity": 0.5 });
                        $("#temperatureImage").css({ "opacity": 1.0 });
                }
        }
}

function selectRain() {
        if (globalVars.state == "place"){
                if (FC.variable != FC.Settings.RAIN_VARIABLE) {
                        FC.variable = FC.Settings.RAIN_VARIABLE;
                        FC.palette = FC.Settings.RAIN_PALETTE;
                        FC.range = FC.Settings.RAIN_RANGE;
                        FC.Map.updateView();
                        updatePaletteControl();
                        showDescription("Expected days of RAIN");

                        if (localStorage.getItem("temp_unit") == "F") {
                                $("#temperatureImage").css({ "background-position": tempatureFOffset });
                        } else {
                                $("#temperatureImage").css({ "background-position": tempatureOffset });
                        }
                        $("#rainImage").css({ "background-position": rainOffsetColoured });
                        $("#sunImage").css({ "background-position": sunOffset });
                        $("#humidityImage").css({ "background-position": humidityOffset });

                        $(".climateIcon").css({ "opacity": 0.5 });
                        $("#rainImage").css({ "opacity": 1.0 });
                }
        }
}

function selectSun() {

        if (globalVars.state == "place"){
                if (FC.variable != FC.Settings.SUN_VARIABLE) {
                        FC.variable = FC.Settings.SUN_VARIABLE;
                        FC.palette = FC.Settings.SUN_PALETTE;
                        FC.range = FC.Settings.SUN_RANGE;
                        FC.Map.updateView();
                        updatePaletteControl();
                        showDescription("Expected % of CLEAR SKY");

                        if (localStorage.getItem("temp_unit") == "F") {
                                $("#temperatureImage").css({ "background-position": tempatureFOffset });
                        } else {
                                $("#temperatureImage").css({ "background-position": tempatureOffset });
                        }
                        $("#rainImage").css({ "background-position": rainOffset });
                        $("#sunImage").css({ "background-position": sunOffsetColoured });
                        $("#humidityImage").css({ "background-position": humidityOffset });

                        $(".climateIcon").css({ "opacity": 0.5 });
                        $("#sunImage").css({ "opacity": 1.0 });
                }
        }
}

function selectHumidity() {
        if (globalVars.state == "place") {
                if (FC.variable != FC.Settings.HUMIDITY_VARIABLE) {
                        FC.variable = FC.Settings.HUMIDITY_VARIABLE;
                        FC.palette = FC.Settings.HUMIDITY_PALETTE;
                        FC.range = FC.Settings.HUMIDITY_RANGE;
                        FC.Map.updateView();
                        updatePaletteControl();
                        showDescription("Expected % of HUMIDITY");

                        if (localStorage.getItem("temp_unit") == "F") {
                                $("#temperatureImage").css({ "background-position": tempatureFOffset });
                        } else {
                                $("#temperatureImage").css({ "background-position": tempatureOffset });
                        }
                        $("#rainImage").css({ "background-position": rainOffset });
                        $("#sunImage").css({ "background-position": sunOffset });
                        $("#humidityImage").css({ "background-position": humidityOffsetColoured });

                        $(".climateIcon").css({ "opacity": 0.5 });
                        $("#humidityImage").css({ "opacity": 1.0 });
                }
        }
}

function showDescription(descriptionText) {
    $("#climateDescription").html(descriptionText);

    $("#leftMarker").css({ "opacity": 0.03 });
    $("#middleMarker").css({ "opacity": 0.03 });
    $("#rightMarker").css({ "opacity": 0.03 });

    $("#leftMarkerText").css({ "opacity": 0.0 });
    $("#middleMarkerText").css({ "opacity": 0.0 });
    $("#rightMarkerText").css({ "opacity": 0.0 });

    $("#climateBlocks").css({"opacity": 0.15});

    //animateMarkers(windowWidth-20, 20, windowWidth-20);

    $("#climateDescription").stop(true, false).fadeIn(function () {
        $("#climateDescription").delay(2000).fadeOut(function () {
    		$("#leftMarker").css({ "opacity": 1.0 });
    		$("#middleMarker").css({ "opacity": 1.0 });
    		$("#rightMarker").css({ "opacity": 1.0 });
    	
    		$("#leftMarkerText").css({ "opacity": 1.0 });
    		$("#middleMarkerText").css({ "opacity": 1.0 });
    		$("#rightMarkerText").css({ "opacity": 1.0 });

            $("#climateBlocks").css({"opacity": 1.0});
        });
    });

}

var lastTimeseries;
var lastUpper;
var lastLower;

function suffixUnits(value) {
	switch (FC.variable) {
	    case FC.Settings.TEMP_VARIABLE:
            return value + "&deg;"
	    case FC.Settings.RAIN_VARIABLE:
            return value + "&nbsp;days"
	    case FC.Settings.SUN_VARIABLE:
            return value + "%&nbsp;"
	    case FC.Settings.HUMIDITY_VARIABLE:
            return value + "%&nbsp;"
        default:
            console.log("Don't know units for: " + FC.variable);
            return value;
    }
}

function suffixBoundsUnits(value) {
    switch (FC.variable) {
        case "airt_upper":
            return value + "&deg;"
        case "wet":
            return value
        case "sun":
            return value + "%&nbsp;"
        case "relhum":
            return value + "%&nbsp;"
        default:
            console.log("Don't know units for: " + FC.variable);
            return value;
    }
}

function updateClimateMarkers() {

	if (!lastTimeseries) {
		$("#middleMarker").hide();
		$("#leftMarker").hide();
		$("#rightMarker").hide();

		$("#middleMarkerText").hide();
		$("#leftMarkerText").hide();
		$("#rightMarkerText").hide();

		return;
	}

	var mid = lastTimeseries[lastMonthIndex];
	var upper = lastUpper[lastMonthIndex];
	var lower = lastLower[lastMonthIndex];

	if (isNaN(mid)) {
		$("#middleMarker").hide();
		$("#leftMarker").hide();
		$("#rightMarker").hide();

		$("#middleMarkerText").hide();
		$("#leftMarkerText").hide();
		$("#rightMarkerText").hide();
		
		$("#climateDescription").html("No details for this location");
	    if ($("#climateDescription").is(":hidden")) {
	        $("#climateDescription").fadeIn().delay(1000).fadeOut();;
	    }

		return;
	}

	$("#middleMarker").show();
	$("#leftMarker").show();
	$("#middleMarkerText").show();
	$("#leftMarkerText").show();
	$("#rightMarker").show();
	$("#rightMarkerText").show();

	//This shouldn't happen, ask Matthew
	if (isNaN(upper)) {
		$("#leftMarker").hide();
		$("#rightMarker").hide();

		$("#leftMarkerText").hide();
		$("#rightMarkerText").hide();
		
		$("#climateDescription").html("Incomplete details for this location");
	    if ($("#climateDescription").is(":hidden")) {
	        $("#climateDescription").fadeIn().delay(1000).fadeOut();;
	    }

		return;
	}


	var midText = suffixUnits(Math.round(convertUnit(mid)));
	var upperText = suffixBoundsUnits("&nbsp;" + Math.round(convertUnit(upper)));
	var lowerText = suffixBoundsUnits("&nbsp;" + Math.round(convertUnit(lower)));

	$("#middleMarkerText h2").html(midText);
	$("#rightMarkerText h2").html(upperText);
	$("#leftMarkerText h2").html(lowerText);

    var fullScale = FC.range.max - FC.range.min;

    var width = $("#climateBlocks").width();

    var midScaled = ((mid - FC.range.min) / fullScale) * width;
    midScaled = Math.min(Math.max(midScaled, 5), width - 5) - ($("#middleMarker").width() /2);
    
    var upperScaled = ((upper - FC.range.min) / fullScale) * width;
    upperScaled = Math.min(Math.max(upperScaled, 5), width - 5) - ($("#rightMarker").width() /2);
    
    var lowerScaled = ((lower - FC.range.min) / fullScale) * width ;;
    lowerScaled = Math.min(Math.max(lowerScaled, 5), width - 5) - $("#leftMarker").width() /2;

    var rightMarkerTextX = upperScaled;
    var leftMarkerTextX = lowerScaled;

    leftMarkerTextX = leftMarkerTextX - $("#leftMarkerText").width() / 2 + $("#leftMarker").width() / 2;
    rightMarkerTextX = rightMarkerTextX - $("#rightMarkerText").width() / 2 + $("#rightMarker").width() / 2;

    var distBetween = Math.abs(upperScaled - lowerScaled);
    var shiftingFactor = 20;

    if (Math.abs(upperScaled - lowerScaled) < shiftingFactor) {
    	leftMarkerTextX = leftMarkerTextX - (shiftingFactor - distBetween + 5) / 2;
    	rightMarkerTextX = rightMarkerTextX + (shiftingFactor - distBetween + 5) / 2;
    }

    //console.log("left :" + String(lowerScaled) + " middle: " + String(midScaled) + " right: " + String(upperScaled));

	$("#middleMarker").css("transform", "translateX(" + midScaled + "px)");
	$("#middleMarkerText").css("transform", "translateX(" + midScaled + "px)");
	$("#rightMarker").css("transform", "translateX(" + upperScaled + "px)");
	$("#rightMarkerText").css("transform", "translateX(" + rightMarkerTextX + "px)");
	$("#leftMarker").css("transform", "translateX(" + lowerScaled + "px)");
	$("#leftMarkerText").css("transform", "translateX(" + leftMarkerTextX + "px)");
}

function drawMinMaxIndicators(data) {
	if (data.timeseries) {
		lastTimeseries = data.timeseries;
	}
	if (data.upper) {
		lastUpper = data.upper;
	}
	if (data.lower) {
		lastLower = data.lower;
	}
	updateClimateMarkers();
}

function animationTest() {
        var fromVariable = FC.Settings.TEMP_VARIABLE,
                toVariable = FC.Settings.WIND_VARIABLE,
                fromPalette = FC.Settings.TEMP_PALETTE,
                toPalette = FC.Settings.WIND_PALETTE,
                fromRange = FC.Settings.TEMP_RANGE,
                toRange = FC.Settings.WIND_RANGE,
                fromColors = fromPalette.split(","),
                toColors = toPalette.split(","),
                colorsNum = fromColors.length,
                stepsNum = 10,
                delay = 50,
                frame = 0,
                curPalette, curRange,
                fromColor, toColor,
                paletteStep, curPaletteStep, gradPalette,
                minRangeStep, curMinRangeStep,
                maxRangeStep, curMaxRangeStep;

        paletteStep = 1 / stepsNum;
        curPaletteStep = 0;
        minRangeStep = (toRange.min - fromRange.min) / stepsNum;
        maxRangeStep = (toRange.max - fromRange.max) / stepsNum;
        curMinRangeStep = fromRange.min;
        curMaxRangeStep = toRange.min;

        var renderAnimationFrame = function () {
                curPalette = "";

                for (var j = 0; j < colorsNum; ++j) {
                        fromColor = fromColors[j];
                        toColor = toColors[j];
                        gradPalette = D3.ColorPalette.parse(fromColor + "," + toColor);
                        curPalette += rgba2hex(gradPalette.getRgba(curPaletteStep)) + ",";
                }

                curRange = { min: curMinRangeStep, max: curMaxRangeStep };

                FC.palette = curPalette.slice(0, -1);
                FC.range = FC.Settings.WIND_RANGE;

                if (frame > stepsNum / 2) {
                        FC.variable = toVariable;
                }

                curPaletteStep += paletteStep;
                curMinRangeStep += minRangeStep;
                curMaxRangeStep += maxRangeStep;
                frame++;

                FC.Map.updateView();

                if (frame <= stepsNum) setTimeout(renderAnimationFrame, delay);
        };

        setTimeout(renderAnimationFrame, delay);
}

// convert RGBA color data to hex
function rgba2hex(c) {
    if (c.r > 255 || c.g > 255 || c.b > 255 || c.a > 255)
        throw "Invalid color component";
    return "#" + (256 + c.r).toString(16).substr(1) +((1 << 24) + (c.g << 16) | (c.b << 8) | Math.round(256 * c.a)).toString(16).substr(1);
}

function restoreUIBlockSizes(){
        
        globalVars.state="home";
        
        $("#place").animate({"height": "33%"});
        $("#place h1").animate({"margin-top": "80px"});
        $("#time").animate({"height": "calc(34% - 6px)"});
        $("#time").animate({"top": "33%"});
        
        $("#time h1").animate({"margin-top": "80px"});
        $("#climate").animate({"height": "34%"});
        $("#climate").animate({"top": "67%"});
        
        $("#map").animate({opacity:0}, function(){
                $("#map").hide();
        }); 
}

function init() {
        FC.month = FC.Settings.DEFAULT_MONTH;
        FC.variable = FC.Settings.TEMP_VARIABLE;
        FC.palette = FC.Settings.TEMP_PALETTE;
        FC.range = FC.Settings.TEMP_RANGE;
        FC.Map.init();
        FC.heatmaps = new FC.Map.HeatmapCollection(FC.Settings.HEATMAPS_NUM_LIMIT);
        FC.Map.updateChartOnMapLoad();
}

var paletteGlobalVariable = null;
var climateVariableGlobalVariable = "airt";

function toggleSettings(toHide, toShow)
{
    $(toHide).hide();
    $(toShow).show();
}

function setUnit(param, value) {
    localStorage.setItem(param, value);
    $(".pref-"+param+"-value").removeClass("pref-selected");
    $("#pref-"+param+"-"+value).addClass("pref-selected");


        if (localStorage.getItem("temp_unit") == "F") {
            if (FC.variable === FC.Settings.TEMP_VARIABLE) {
                $("#temperatureImage").css({ "background-position": tempatureFOffsetColoured });
            } else {
                $("#temperatureImage").css({ "background-position": tempatureFOffset });
            }
        } else {
            if (FC.variable === FC.Settings.TEMP_VARIABLE) {
                $("#temperatureImage").css({ "background-position": tempatureOffsetColoured });
            } else {
                $("#temperatureImage").css({ "background-position": tempatureOffset });
            }
        }
        updateClimateMarkers();

    return true;
}

function getUnit(param) {
    return localStorage.getItem(param);
}

// Celsium to Fahrenheit
function degreeCtoF(c) {
    return 1.8 * c + 32;
}

function rainPercToMM(r) {
    return 
}

function convertUnit(value) {
    switch (FC.variable) {
        case FC.Settings.TEMP_VARIABLE:
        if (localStorage.getItem("temp_unit") == "F") {
            value = degreeCtoF(value);
        }
        break;
        case FC.Settings.RAIN_VARIABLE:
        if (localStorage.getItem("rain_unit") == "mm") {
            
        }
        break;
        case FC.Settings.SUN_VARIABLE:
        if (localStorage.getItem("sun_unit") == "") {
            
        }
        break;
        case FC.Settings.HUMIDITY_VARIABLE:
        if (localStorage.getItem("relhum_unit") == "") {
            
        }
        break;
    default:
        console.log("Don't know units for: " + FC.variable);
    }
    
    return value;
}

function initSettings() {
	
    if (getUnit("temp_unit") == null) {
	console.log("it's undefined");
	setUnit("temp_unit", "C")
    }
    var settings = ["temp_unit", ];
    settings.forEach(function(entry) {
        // something like pref-temp_unit-C
        $("#pref-"+entry+"-"+localStorage.getItem(entry)).addClass("pref-selected");
    });
}

function openSettings() {
    $('#settings-main').show();
    $('#popup-background').show();
    $("#about-text").css("height", $("#settings-main").height()*0.39);
}

function popupClose() {
	$('.popup').hide();
}

function showDownloadIndicator(ind) {
	ind.css({"max-height" : "1em", "padding" : "1ex 0"});
}
function hideDownloadIndicator(ind) {
	ind.css({"max-height" : 0, "padding" : 0});
}