function phonegap_share(event)
{
    swapShareToLoading();
    //window.onerror = function (message, file, line) {
    //    window.external.Notify("Error in Application: " +
    //                            message + ". Source File: " + file + ", Line: " + line);
    //}
    //
    //event.stopPropagation();
    //window.external.Notify(""+window.device);
    //window.external.Notify(""+navigator.splashscreen);
    //window.external.Notify(""+device.platform);
    //window.external.Notify(""+device);
    
        
    if (typeof (device) == 'undefined') {
        alert("Sorry, your platform doesn't support sharing at the moment. Watch out for an app update.");
        swapLoadingToShare();
        return
    }
    
    var defaultMessage = "Try out Climatology to find the best climate for you.";
    var message = defaultMessage;
    var condition = Math.round(lastTimeseries[lastMonthIndex]);
    
    try {
        if (isNaN(condition)) {
            message = defaultMessage;
        } else if (FC.variable == FC.Settings.TEMP_VARIABLE) {
            message = "A typical "+ getMonthName() +" "+ getPlace() + " has a temperature of "+ condition+"C.";
        } else if (FC.variable == FC.Settings.SUN_VARIABLE) {
            message = getPlaceNoPreposition() + " is sunny in "+ getMonthName() +" about " + condition+ "% of the time."
            //message = getPlaceNoPreposition() + " is sunny in "+ getMonthName() +" about " + condition+ "%] of the time, although it can get up to [16%]. @MSRClimatology (99 chars)    
        } else if (FC.variable == FC.Settings.RAIN_VARIABLE) {
            message = "Typically, "+ getPlaceNoPreposition() + " has about "+ condition +" days of rain in " + getMonthName() +"."; 
            //Typically, [Paris] has about [8] days of rain in [September]. It can have as many as [12] and as few as [6]. @MSRClimatology  (116 chars)[0%]. @MSRClimatology (112 chars)        
        } else if (FC.variable == FC.Settings.HUMIDITY_VARIABLE) {
            message = "The humidity "+ getPlace() +" is typically about "+ condition +"% in "+getMonthName()+"."
            //message = "The humidity "+ getPlace() +" is typically about "+ condition +"% in "+getMonthName()+". It can get up to [30%] and as low as 
        } else {
            message = defaultMessage;
        }
    } catch(e) {
        message = defaultMessage;
    }
    
    subject = "Climatology App";
    title = "Climatology App";
    file_ = null;
    link = "http://research.microsoft.com/climatology/"
    
    if (device.platform == "Android" || device.platform == "iOS") {
        navigator.screenshot.save(function(error,res){
            if(error){
                console.error(error);
                file_ = null;
            }else{
                file_ = "file://"+res.filePath;
                console.log('ok',res.filePath);
            }
            window.plugins.socialsharing.share(message, subject, file_, link, shareSuccess, shareFail);
        });
    } else if (device.platform == "Win32NT") {
        title = "Check out the Climatology App";
        window.plugins.socialsharing.share(message, title, null, link, shareSuccess, shareFail);
    } else {
        alert("Sorry, your platform ("+ device.platform +") doesn't support sharing at the moment. Watch out for an app update.");
        swapLoadingToShare();
    }
    
    
}

function getMonthName() {
    return monthNames[lastMonthIndex].charAt(0).toUpperCase() + monthNames[lastMonthIndex].slice(1).toLowerCase();
}

function getPlace() {
    if ($("#place_text").is(":visible") ) {
        place = "in " + $("#place_text").text()
    } else if ( $("#latlon").is(":visible") ) {
        place = "at coordinates " + $("#latlon").text().replace(/\n/g, '').replace(/ +/g, ' ');
    }
    return place;
}

function shareSuccess(args) {
    swapLoadingToShare();
}

function shareFail(){
    swapLoadingToShare();
}

function swapShareToLoading() {
    $("img#iconShare").attr("src", "images/icon-share_smaller.png");
}
function swapLoadingToShare() {
    $("img#iconShare").attr("src", "images/icon-share.png");
}

function getPlaceNoPreposition() {
    if ($("#place_text").is(":visible") ) {
        place = $("#place_text").text()
    } else if ( $("#latlon").is(":visible") ) {
        place = $("#latlon").text().replace(/\n/g, '').replace(/ +/g, ' ');
    }
    return place;
}